package com.zipcodewilmington.generic.group;

import com.zipcodewilmington.generic.identifiables.IdentifiableInterface;

import java.io.Serializable;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author leon on 06/12/2018.
 */
public class Group<TypeOfId extends Serializable,
        TypeOfEntity extends IdentifiableInterface> extends AbstractGroup{

    List<TypeOfEntity> list = new ArrayList<>();

    @Override
    public Integer count() {
        return list.size();
    }

    @Override
    public void insert(IdentifiableInterface object) {
        list.add((TypeOfEntity) object);
    }

    @Override
    public void delete(IdentifiableInterface object) {
        list.remove(object);
    }

    @Override
    public void delete(Serializable serializable) {
        for (int i = 0; i < list.size(); i++) {
            if (list.get(i).getIdentity() == serializable) {
                list.remove(list.get(i));
            }
        }
    }

    @Override
    public Boolean has(IdentifiableInterface object) {
        return list.contains(object);
    }

    @Override
    public Boolean has(Serializable serializable) {
        return list.contains(serializable);
    }

    @Override
    public List<TypeOfEntity> filter(Predicate predicate) {
        return (List<TypeOfEntity>) list.stream().filter(predicate).collect(Collectors.toList());
    }

    @Override
    public Class getIdentityType() {
        return list.get(0).getIdentity().getClass();
    }

    @Override
    public Class getIdentifiableType() {
        return list.get(0).getClass();
    }

}
